<?php

/*	Vulpes - Gateway Access Manager
	Copyright © 2007, 2008 LinFox Serviços em Informatica LTDA.

	This file is part of Vulpes.

	Vulpes is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Vulpes is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Vulpes.  If not, see <http://www.gnu.org/licenses/>. */

date_default_timezone_set('America/Recife');

require 'config.php';
require 'lib/db.php';
require 'lib/functions.php';
require 'lib/config.php';
require_once 'lib/changes.php';
require_once 'dao/config_dao.php';
require_once 'dao/user_dao.php';
require_once 'dao/contract_dao.php';
require_once 'dao/client_dao.php';
require_once 'dao/log_dao.php';
require_once 'ctl/netcontrol_ctl.php';

$config = config::get_instance();
$timestamp_now = date('YmdHis');
$timestamp_log = date('Y-m-d H:i:s');
$timestamp_timeout = date('YmdHis', mktime(date('H'),date('m')-60));
$past_month = date('m', mktime(0,0,0,date('m')-1));
$arp = arp();

$client_dao = new client_dao();
$contract_dao = new contract_dao();
$contracts = $contract_dao->fetch_cron();
$log_dao = new log_dao();
$log_dao->prune($config->log_prune);

foreach ($contracts as $contract) {
	$client_found = false;
	$timestamp = $contract->client_timestamp;
	$timestamp = str_replace('-','',$timestamp);
	$timestamp = str_replace(' ','',$timestamp);
	$timestamp = str_replace(':','',$timestamp);

	if ($contract->last_unpaid_invoice_date
		&& $config->block_overdue != 0
		&& $contract->plan_price > 0
		&& $contract->status == 'L') {
//		$y = substr($contract->last_unpaid_invoice_date,0,4);
//		$m = substr($contract->last_unpaid_invoice_date,5,2);
//		$d = substr($contract->last_unpaid_invoice_date,8,2);
//		$dateout = date('Ymd', mktime(0, 0, 0, $m, $d + $config->payment_delay, $y));

//		echo "\n".$dateout."\n".$contract->last_invoice."\n";
//		// If the newest invoice is overdue block the contract (and disable the client while we're at it).
//		if (date('Ymd') > ($dateout) && $contract->plan_price > 0) {
		exec('echo "'.$timestamp_log.': Blocking '.$contract->client_username.' ('.$contract->last_unpaid_invoice_date.' + '.$config->payment_delay.'d < '.date('Y-m-d').' - R$ '.$contract->total_unpaid_value.')" >> /var/log/vulpes.log');
		$contract->status = 'I';
		$contract_dao->update($contract);
	}

	foreach ($arp as $row) {
		if ($row['ip_address'] == $contract->ip && strtoupper($row['hw_address']) == strtoupper($contract->mac) && $contract->status == 'L') {
			if ($client_dao->update_timestamp($contract->client_id)) {
//				exec('echo "'.$timestamp_log.': Found client '.$contract->client_username.' in ARP. Updated timestamp to '.$contract->last_access.'" >> /var/log/vulpes.log');
				$contract->last_access = $timestamp_now;
			} else {
				exec('echo "'.$timestamp_log.': WARNING: Found client '.$contract->client_username.' in ARP, but couldnt update timestamp to '.$contract->last_access.'" >> /var/log/vulpes.log');
			}
			$client_found = true;
		}
	}
//	exec('echo "'.$timestamp_log.': '.$contract->client_username.' ('.$contract->client_timestamp.' - '.$timestamp.' - '.$timestamp_timeout.')" >> /var/log/vulpes.log');
	if ($timestamp_timeout > $timestamp && $contract->client_active) {
		if ($client_dao->disactivate($contract->client_id)) {
			exec('echo "'.$timestamp_log.': Disactivating '.$contract->client_username.' ('.$contract->client_timestamp.')" >> /var/log/vulpes.log');
		} else {
			exec('echo "'.$timestamp_log.': WARNING: '.$contract->client_username.' reached timeout ('.$contract->client_timestamp.' < '.$timestamp_timeout.') but couldnt disactivate him." >> /var/log/vulpes.log');
		}
	}
}

$netcontrol = new netcontrol_ctl();
$netcontrol->refresh_iptables();
$netcontrol->refresh_tc();

?>
