<?php

/*	Vulpes - Gateway Access Manager
	Copyright © 2007, 2008 LinFox Serviços em Informatica LTDA.

	This file is part of Vulpes.

	Vulpes is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Vulpes is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Vulpes.  If not, see <http://www.gnu.org/licenses/>. */

require_once 'lib/controller.php';
require_once 'dao/contract_dao.php';
require_once 'dao/client_dao.php';
require_once 'dao/plan_dao.php';
require_once 'dao/invoice_dao.php';

class contract_ctl extends controller
{
	protected $mode = 'contracts';
	protected $model = 'contract';
	protected $dao = 'contract_dao';
	
	function __construct()
	{
		parent::__construct();
	}

	function cancel()
	{
		$contract_dao = new contract_dao();
		$contract = $contract_dao->fetch(get('handle'));
		$contract->status = 'C';
		$contract->canceled = date('Y-m-d');
		$contract_dao->update($contract);
		return $this->show_all();
	}
	
	function insert()
	{
		global $user;
		$client_dao = new client_dao();
		$contract_dao = new contract_dao();

		$client = $client_dao->fetch(get($client_dao->key));
		$contract = $contract_dao->fetch_model();
		$contract->get_request();
		$contract->date = date('Y-m-d');
		$contract->user_id = $user->user_id;
		$contract_dao->insert($contract);
		changes::get_instance()->mark($this->mode);
//		$this->insert_invoice($contract);
		return $this->show(get($contract_dao->key));
	}

	function insert_invoice($contract = false)
	{
		$plan_dao = new plan_dao();
		$invoice_dao = new invoice_dao();

		$plan = $plan_dao->fetch($contract->plan_id);
		if ($plan->price == 0) return true;

		$paytime = mktime(0,0,0,date('m')+1,$contract->payday,date('Y'));
		$invoice = $invoice_dao->fetch_model();
		$invoice->handle = $contract->handle;
		$invoice->period_start = date('Y-m-d');
		$invoice->period_end = date('Y-m-t');
		$invoice->date = date('Y-m-d',$paytime);
		$invoice->value = ($plan->price / date('t')) * (date('t') - date('d'));
		return $invoice_dao->insert($invoice);
	}
	
	function liberate()
	{
		$contract_dao = new contract_dao();
		$contract = $contract_dao->fetch(get($contract_dao->key));
		$contract->status = 'L';
		$contract_dao->update($contract);
		changes::get_instance()->mark($this->mode);
		return $this->show();
	}

	function block()
	{
		$contract_dao = new contract_dao();
		$contract = $contract_dao->fetch(get($contract_dao->key));
		$contract->status = 'B';
		$contract_dao->update($contract);
		changes::get_instance()->mark($this->mode);
		return $this->show();
	}
	
	function delete() {}

}

?>