<?php

/*	Vulpes - Gateway Access Manager
	Copyright © 2007, 2008 LinFox Serviços em Informatica LTDA.

	This file is part of Vulpes.

	Vulpes is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Vulpes is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Vulpes.  If not, see <http://www.gnu.org/licenses/>. */

require_once 'lib/controller.php';
require_once 'dao/invoice_dao.php';
require_once 'dao/client_dao.php';
require_once 'dao/boleto_dao.php';
require_once 'xoo/xml_xoo.php';
require_once 'xoo/invoice_xoo.php';

class invoice_ctl extends controller
{
	protected $mode = 'invoices';
	protected $model = 'invoice';
	protected $dao = 'invoice_dao';
	protected $xoo = 'xml_xoo';
	public $tpl = 'xml_tpl';
	
	function __construct()
	{
		parent::__construct();
	}

	public function show()
	{
		$dao = new $this->dao();
		$model = $dao->fetch(get($dao->key));
		$model->fine = 0;
		$model->interest = 0;
		if (strtotime($model->date) <= mktime(0,0,0,date('m'),date('d')-5,date('Y')) && $model->value > $model->paid) {
			$model->fine = round(($model->value / 100) * 5,2);
			$model->interest = round(
				(
					( mktime(0,0,0,date('m'),date('d')-5,date('Y')) - strtotime($model->date) )
					/ 60 / 60 / 24
				) * (
					($model->value / 100) * 0.17
				), 2);
		}
		$model->total = $model->value + $model->fine + $model->interest;
		$xoo = new $this->xoo();
		return $xoo->item($model, $this->model);
	}

	public function output_all($models)
	{
		$xoo = new $this->xoo();
		$paid = 0;
		$value = 0;
		foreach ($models as $model) {
			$model->fine = 0;
			$model->interest = 0;
			if (strtotime($model->date) <= mktime(0,0,0,date('m'),date('d')-5,date('Y')) && $model->value > $model->paid) {
				$model->fine = round(($model->value / 100) * 5,2);
				$model->interest = round(
					(
						( mktime(0,0,0,date('m'),date('d')-5,date('Y')) - strtotime($model->date) )
						/ 60 / 60 / 24
					) * (
						($model->value / 100) * 0.17
					), 2);
			}
			$model->total = $model->value + $model->fine + $model->interest;
			$paid += $model->paid;
			$value += $model->value;
		}
		$result = $xoo->items($models, $this->model);
		$result .= $xoo->property($paid,'paid');
		$result .= $xoo->property($value,'value');
		return $xoo->wrap($result,$this->mode);
	}
	
	public function show_all()
	{
		$dao = new $this->dao($this->db);
		$model = $dao->fetch_model();
		$model->get_request();

		if (get('type')) {
			$method = 'fetch_'.get('type');
		} else {
			$method = 'fetch_all';
		}
		$models = $dao->$method($model);
		return $this->output_all($models);
	}

	public function search_all()
	{
		$dao = new $this->dao($this->db);
		$model = $dao->fetch_model();
		$model->get_request();
		if (get('type')) {
			$method = 'fetch_'.get('type').'_like';
		} else {
			$method = 'fetch_all_like';
		}
		$models = $dao->$method($model,get('search'));
		return $this->output_all($models);
	}

	public function cancel()
	{
		$dao = new $this->dao($this->db); 
		$model = $dao->fetch(get($dao->key));
		$model->status = 'C';
		$dao->update($model);
		$key = $dao->key;
		return $this->show();
	}

	public function delete()
	{
		return $this->cancel();
	}

	public function emit()
	{
		$dao = new $this->dao();
		$model = $dao->fetch_model();
		$model->get_request();
		$period_time = strtotime(get('period_start'));
		$period_time_end = strtotime(get('period_end'));
		while ($period_time <= $period_time_end) {
			$dao->emit($model,$period_time);
			$period_time = mktime(0,0,0,date('m',$period_time)+1,date('d',$period_time),date('Y',$period_time));
		}
		return $this->show_all();
	}
	
	function bill()
	{
		$this->tpl = 'invoice_tpl';
		$dao = new boleto_dao();
		$invoices = $dao->fetch_all(get($dao->key));
		$xoo = new invoice_xoo();
		$result = '';
		foreach ($invoices as $invoice) {
			$result .= $xoo->boleto($invoice);
		}
		return $result;
	}

}

?>