<?php

/*	LibFox - Simple library for XML-based backends.
	Copyright © 2007, 2008 LinFox Serviços em Informatica LTDA.

	This file is part of LibFox.

	LibFox is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	LibFox is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with LibFox.  If not, see <http://www.gnu.org/licenses/>. */

require_once 'lib/controller.php';
require_once 'dao/log_dao.php';

class log_ctl extends controller
{
	protected $mode = 'logs';
	protected $model = 'log';
	protected $dao = 'log_dao';

	public function __construct()
	{
		parent::__construct();
	}

	public function insert()
	{
		global $user;

		$dao = new $this->dao();
		$model = $dao->fetch_model();

		// If the log table has any custom fields then this will grab
		// those values.
		$model->get_request();
		$model->user_id = $user->user_id;
		$model->mode = get_mode();
		$model->action = get_action();
		$model->request = '';
		foreach ($_REQUEST as $key => $value) {
			// Strip the prefix if it is present
			if (substr($key,0,3) == setup::prefix) {
				$key = substr($key,3);
				if (!isset($model->$key) && $value = get($key))
					// Make sure very large (probably irrelevant)
					// values aren't stored.
					if (strlen($value) <= 32)
						$model->request .= $key.': '.$value.', ';
			}
		}
		$model->request = substr($model->request, 0, -2);
		$dao->insert($model);
		return true;
	}
}

?>