<?php

/*	Vulpes - Gateway Access Manager
	Copyright © 2007, 2008 LinFox Serviços em Informatica LTDA.

	This file is part of Vulpes.

	Vulpes is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Vulpes is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Vulpes.  If not, see <http://www.gnu.org/licenses/>. */

require_once 'lib/controller.php';
require_once 'dao/plan_dao.php';
require_once 'dao/schedule_dao.php';

/**
 * Plans Controller
 */
class plan_ctl extends controller
{
	protected $mode = 'plans';
	protected $model = 'plan';
	protected $dao = 'plan_dao';

	function __construct()
	{
		parent::__construct();
	}

	function show_all()
	{
		$dao = new $this->dao($this->db);
		$model = $dao->fetch_model();
		$model->get_request();
		$models = $dao->fetch_all($model);
		$xoo = new $this->xoo();
		$result = $xoo->items($models, $this->model, $this->mode);
		$result .= '
			<days>
				<day>
					<value>all</value>
					<label>'.lang::all.'</label>
				</day>
				<day>
					<value>workday</value>
					<label>'.lang::workday.'</label>
				</day>
				<day>
					<value>weekend</value>
					<label>'.lang::weekend.'</label>
				</day>
				<day>
					<value>monday</value>
					<label>'.lang::monday.'</label>
				</day>
				<day>
					<value>tuesday</value>
					<label>'.lang::tuesday.'</label>
				</day>
				<day>
					<value>wednesday</value>
					<label>'.lang::wednesday.'</label>
				</day>
				<day>
					<value>thursday</value>
					<label>'.lang::thursday.'</label>
				</day>
				<day>
					<value>friday</value>
					<label>'.lang::friday.'</label>
				</day>
				<day>
					<value>saturday</value>
					<label>'.lang::saturday.'</label>
				</day>
				<day>
					<value>sunday</value>
					<label>'.lang::sunday.'</label>
				</day>
			</days>';

		return $result;
	}
	
	function insert_schedule()
	{
		$schedule_dao = new schedule_dao();
		$schedule = $schedule_dao->fetch_model();
		$schedule->get_request();
		$schedule_dao->insert($schedule);
		changes::get_instance()->mark($this->mode);
		return $this->show();
	}
	
	function remove_schedule()
	{
		$schedule_dao = new schedule_dao();
		$schedule_dao->delete(get($schedule_dao->key));
		changes::get_instance()->mark($this->mode);
		return $this->show();
	}

}

?>