<?php

/*	LibFox - Simple library for XML-based backends.
	Copyright © 2007, 2008 LinFox Serviços em Informatica LTDA.

	This file is part of LibFox.

	LibFox is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	LibFox is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with LibFox.  If not, see <http://www.gnu.org/licenses/>. */

require_once 'lib/controller.php';
require_once 'dao/schedule_dao.php';
require_once 'xoo/xml_xoo.php';

class schedule_ctl extends controller
{
	protected $mode = 'schedules';
	protected $model = 'schedule';
	protected $dao = 'schedule_dao';
	protected $xoo = 'xml_xoo';
	public $tpl = 'xml_tpl';
	
	public function __construct()
	{
		parent::__construct();
	}

	public function show()
	{
		$dao = new $this->dao();
		$model = $dao->fetch(get($dao->key));
		$model->day_name = lang::get($model->day);
		$xoo = new $this->xoo();
		return $xoo->item($model, $this->model);
	}

	public function show_all()
	{
		$dao = new $this->dao($this->db);
		$model = $dao->fetch_model();
		$model->get_request();
		$models = $dao->fetch_all($model);
		foreach ($models as &$model) {
			$model->day_name = lang::get($model->day);
		}
		$xoo = new $this->xoo();
		return $xoo->items($models, $this->model, $this->mode);
	}

}

?>