<?php

/*	Vulpes - Gateway Access Manager
	Copyright © 2007, 2008 LinFox Serviços em Informatica LTDA.

	This file is part of Vulpes.

	Vulpes is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Vulpes is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Vulpes.  If not, see <http://www.gnu.org/licenses/>. */

require_once 'lib/dao.php';

class log_dao extends dao
{
	public $key = 'log_id';
	public $foreign_keys = 'user_id,client_id';
	protected $table = 'log';
	protected $fields_rel_all = array(
		'user_username' => array('users' => 'username'),
		'user_name' => array('users' => 'name'),
		'client_name' => array('clients' => 'name') );
	protected $left_joins = array(
		'users.user_id' => 'log.user_id',
		'clients.client_id' => 'log.client_id');
	protected $search_fields = 'log.mode,log.action,log.request,users.username,users.name,clients.username,clients.name';
	protected $delete_rel = 'schedules';
	public $order_by = 'date_time-';
	public $group_by = 'log_id';

	function __construct()
	{
		parent::__construct();
	}

	public function prune($days = 90)
	{
		$time = mktime(date('H'),date('m'),date('s'),date('m'),date('d')-$days,date('y'));
		$sql = 'DELETE FROM `'.$this->table.'`
			WHERE `date_time` < "'.date('Y-m-d H:m:s',$time).'"';
		$this->db->query($sql);
	}
}

?>