<?php

/*	Vulpes - Gateway Access Manager
	Copyright © 2007, 2008 LinFox Serviços em Informatica LTDA.

	This file is part of Vulpes.

	Vulpes is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Vulpes is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Vulpes.  If not, see <http://www.gnu.org/licenses/>. */

require_once 'lib/model.php';

class netcontrol_dao
{
	protected $model = 'model';

	public function __construct()
	{
		$this->db = db::get_instance();
	}

	public function fetch_contracts($day = false, $time = false)
	{
		$contracts = array();
		$day = strtolower($day);
		if ($day == 'saturday' || $day == 'sunday') {
			$week_part = 'weekend';
		} else {
			$week_part = 'workday';
		}
		$contracts_sql = '
			SELECT
				`contracts`.`handle`,
				`contracts`.`ip`,
				`contracts`.`mac`,
				`contracts`.`status`,
				`clients`.`username`,
				`clients`.`active`,
				`plans`.`iface`,
				`plans`.`download`,
				`plans`.`upload`,
				`plans`.`auth`,
				`plans`.`bind_mac`,
				`plans`.`proxy_port`,
				`plans`.`ttl_limit`,
				COUNT(`schedules`.`day`) AS `scheduled`,
				`schedules`.`upload` AS `upload_sched`,
				`schedules`.`download` AS `download_sched`
			FROM `contracts`
			INNER JOIN `clients` ON (
				`contracts`.`client_id` = `clients`.`client_id` )
			INNER JOIN `plans` ON (
				`plans`.`plan_id` = `contracts`.`plan_id`)
			LEFT JOIN `schedules` ON (
				`schedules`.`plan_id` = `plans`.`plan_id` )
			WHERE ( `schedules`.`day` = "'.addslashes($day).'"
				OR `schedules`.`day` = "'.$week_part.'"
				OR `schedules`.`day` = "all" )
				AND `schedules`.`start` < "'.addslashes($time).'"
				AND `schedules`.`end` > "'.addslashes($time).'"
			GROUP BY `contracts`.`ip`';
		$result = $this->db->query($contracts_sql);
		$result->setFetchMode(PDO::FETCH_CLASS,$this->model);
		return $result->fetchAll();
	}

}

?>