<?php

/*	Vulpes - Gateway Access Manager
	Copyright © 2007, 2008 LinFox Serviços em Informatica LTDA.

	This file is part of Vulpes.

	Vulpes is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Vulpes is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Vulpes.  If not, see <http://www.gnu.org/licenses/>. */

require_once 'lib/dao.php';

class payment_dao extends dao
{
	public $key = 'payment_id';
	public $foreign_keys = 'invoice_id';
	protected $table = 'payments';
	protected $fields_rel_all = array(
		'user_username' => array('users' => 'username'),
		'client_name' => array('clients' => 'name'),
		'invoice_date' => array('invoices' => 'date'),
		'plan_name' => array('plans' => 'name') );
	protected $fields_sum = array(
		'value' => array('payments' => 'value') );
	protected $select_sql = 'DATE_FORMAT(`payments`.`date`, "%Y-%m") AS `month`, DATE_FORMAT(`invoices`.`date`, "%Y-%m") AS `invoice_month`';
	protected $left_joins = array(
		'users.user_id' => 'payments.user_id',
		'invoices.invoice_id' => 'payments.invoice_id',
		'contracts.handle' => 'invoices.handle',
		'clients.client_id' => 'contracts.client_id',
		'plans.plan_id' => 'contracts.plan_id' );
	protected $where = '`payments`.`status` <> "C"';
	protected $search_fields_l = 'payments.date,clients.name,plans.name';
	public $group_by = 'payment_id';

	public function __construct()
	{
		parent::__construct();
	}

}

?>