<?php

/*	LibFox - Simple library for XML-based backends.
	Copyright © 2007, 2008 LinFox Serviços em Informatica LTDA.

	This file is part of LibFox.

	LibFox is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	LibFox is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with LibFox.  If not, see <http://www.gnu.org/licenses/>. */

require_once 'lib/dao.php';
require_once 'mdl/user.php';

class user_dao extends dao
{
	public $key = 'user_id';
	protected $table = 'users';
	protected $model = 'user';
	protected $hash = 'sha512';
	public $group_by = 'user_id';

	public function __construct()
	{
		parent::__construct();
	}

	/**
	 * Verifica se o usuario esta autenticado
	 * 
	 * em caso que nao, tenta autenticar usando os valores no $_POST
	 * em caso que o usuario é autenticado, os dados sao guardados nas variaveis desse class
	 */
	public function auth($username = false, $password = false)
	{
		if ( (array_key_exists('action',$_POST) && $_POST['action'] == 'logout')
		|| ( array_key_exists('action',$_GET) && $_GET['action'] == 'logout') ) {
			$_SESSION = array();
			session_destroy();
			return false;
		} elseif ($username && $password) {
			$sql_user = '
				SELECT *
				FROM `'.$this->table.'`
				WHERE `username` = "' .$username. '"
					AND `password` = "' .hash($this->hash, $password). '"';
			$result_user = $this->db->query($sql_user);

			if ($user = $result_user->fetchObject($this->model)) {
				$_SESSION['vulpes_user_session'] = true;
				$_SESSION['vulpes_user_id'] = $user->user_id;
				$_SESSION['vulpes_user_username'] = $user->username;
			} else {
				return false;
			}
			$result_user->closeCursor();
		}

		if ($_SESSION['vulpes_user_session'] == true) {
			if ($user = $this->fetch($_SESSION['vulpes_user_id'])) {
				$user->verified = true;
				$user->permissions = $this->fetch_permissions($user);
				return $user;
			} else {
				return false;
			}
		}
		return false;
	}

	/**
	 * See if user has permissions to $mode/$action.
	 *
	 * @param user $user
	 * @param string $mode
	 * @param string $action
	 */
	public function fetch_permissions(user &$user)
	{
		$perms = array();
		$sql = '
			SELECT `user_permissions`.*
			FROM `user_permissions`
			INNER JOIN `user_members` ON (
				`user_members`.`group_id` = `user_permissions`.`group_id` )
			WHERE ( `user_members`.`'.$this->key.'` = "'.$user->user_id.'"
					OR `user_members`.`'.$this->key.'` = "_ALL" )';
		$result = $this->db->query($sql);
		return $result->fetchAll(PDO::FETCH_CLASS);
	}

	public function update_password(&$user,$password)
	{
		$key = $this->key;
		$sql_update_password = '
			UPDATE `'.$this->table.'`
			SET `password` = "'.hash('sha512', $password).'"
			WHERE `'.$this->key.'` = "'.$user->$key.'"';
		if (!$this->db->query($sql_update_password)) {
			throw new Exception('password_not_saved');
			return false;
		}
		return true;
	}
	
}

?>