<?php

/*	LibFox - Simple library for XML-based backends.
	Copyright © 2007, 2008 LinFox Serviços em Informatica LTDA.

	This file is part of LibFox.

	LibFox is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	LibFox is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with LibFox.  If not, see <http://www.gnu.org/licenses/>. */

require_once 'lib/dao.php';

class user_member_dao extends dao
{
	public $key = 'member_id';
	public $foreign_keys = 'user_id,group_id';
	protected $table = 'user_members';
	protected $fields_rel_all = array(
		'user_username' => array('users' => 'username'),
		'group_name' => array('user_groups' => 'name')
	);
	protected $joins = array(
		'users.user_id' => 'user_members.user_id',
		'user_groups.group_id' => 'user_members.group_id'
	);
	public $group_by = 'member_id';

	public function __construct()
	{
		parent::__construct();
	}

}

?>