<?php

/*	LibFox - Simple library for XML-based backends.
	Copyright © 2007, 2008 LinFox Serviços em Informatica LTDA.

	This file is part of LibFox.

	LibFox is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	LibFox is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with LibFox.  If not, see <http://www.gnu.org/licenses/>. */

session_start();

date_default_timezone_set('America/Recife');

require 'config.php';
require 'lib/db.php';
require 'lib/functions.php';
require 'lib/config.php';
require_once 'lib/changes.php';
require_once 'lib/xoo.php';
require_once 'dao/config_dao.php';
require_once 'dao/user_dao.php';
require_once 'ctl/log_ctl.php';
require_once 'ctl/netcontrol_ctl.php';

$config = config::get_instance();
require_once 'lang/'.$config->language.'.php';

$user_dao = new user_dao();
$user = $user_dao->auth(get('login_username',''),get('login_password',''));

$mode = get_mode();
$action = get_action();
$tpl = 'xml_tpl';
$result = '';

if ($user) {

	try {
		if ($mode && $user->perm($mode,$action)) {
			$ctl_class = $mode.'_ctl';
			if (file_exists('ctl/'.$ctl_class.'.php')) {
				include_once('ctl/'.$ctl_class.'.php');
				$controller = new $ctl_class();
				$log_ctl = new log_ctl();
				$log_ctl->insert();
			} else {
				throw new Exception('Cannot find controller for this mode.');
			}
			$result .= $controller->$action();
			$tpl = $controller->tpl;
		} else {
			throw new Exception('access_denied');
		}
	} catch (Exception $e) {
		$error = $e->getMessage();
	}

	$changes = changes::get_instance();
} else {
	$error = 'Invalid user';
}

include 'tpl/'.$tpl.'.php';

?>