<?php

/*	Vulpes - Gateway Access Manager
	Copyright © 2007, 2008 LinFox Serviços em Informatica LTDA.

	This file is part of Vulpes.

	Vulpes is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Vulpes is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Vulpes.  If not, see <http://www.gnu.org/licenses/>. */

date_default_timezone_set('America/Recife');
session_start();
header('Content-Type: text/html; charset=utf-8');
header('Cache-Control: no-cache, must-revalidate');
header('Pragma: no-cache');

require 'config.php';
require 'lib/db.php';
require 'lib/functions.php';
require 'lib/config.php';
require_once 'lib/changes.php';
require_once 'dao/config_dao.php';
require_once 'dao/user_dao.php';
require_once 'dao/contract_dao.php';
require_once 'dao/client_dao.php';
require_once 'ctl/netcontrol_ctl.php';

$config = config::get_instance();
require_once 'lang/'.$config->language.'.php';

$client_dao = new client_dao();
$contract_dao = new contract_dao();

try {
	$contract = $contract_dao->fetch_model();
	$contract->ip = $_SERVER['REMOTE_ADDR'];
	$contract = $contract_dao->fetch($contract);

	$client = $client_dao->auth();

	$uri = 'http://'.$_GET['vulpes_http_host'].$_GET['vulpes_request_uri'].$_GET['vulpes_query_string'];

	if ($contract->status == 'B' || $contract->status == 'I') {
		throw new Exception('Seu contrato foi bloqueado, por favor entre em contato com suporte tecnico.');
	} elseif ($client->client_id == $contract->client_id) {
		if (!$client->active) {
			$client_dao->activate($client->client_id);
		}
	//	$netcontrol = new netcontrol_ctl();
	//	$netcontrol->refresh_iptables();
		if ($_POST['client_login_uri']) {
			$refresh_uri = $_POST['client_login_uri'];
		} else {
			$refresh_uri = $uri;
		}
		$refresh = '<meta http-equiv="refresh" content="7;url='.$refresh_uri.'">';
		$content = '
			Você esta sendo redirecionado para: <a href="'.$refresh_uri.'">'.$refresh_uri.'</a><br/>
			Se voce nao esta sendo redirecionado, <a href="http://www.google.com/">clique aqui</a>.';
	} elseif (isset($_POST['client_login_uri'])) {
		$refresh = '<meta http-equiv="refresh" content="5;url='.$_POST['client_login_uri'].'">';
		$content = 'Voce sera redirecionado para a tela de login em cinco segundos.';
		throw new Exception('Login ou senha invalido!');
	} else {
		$content = '
			<form action="http://'.$config->ip.':'.$config->cp_port.'/login.php" method="post">
				<input type="hidden" name="client_login_uri" value="'.$uri.'"/>
				<table>
					<tr>
						<th><label for="lf_client_username">Usuario</label></th>
						<th><label for="lf_client_password">Senha</label></th>
					</tr>
					<tr>
						<td><input type="text" id="lf_client_username" name="lf_client_username" value=""/></td>
						<td><input type="password" id="lf_client_password" name="lf_client_password" value=""/></td>
					</tr>
				</table>
				<button type="submit">Login</button>
			</form>
			';
	
	}
} catch (Exception $e) {
	$error = $e->getMessage();
}

include('tpl/login_tpl.php');

?>
