<?php

/*	LibFox - Simple library for XML-based backends.
	Copyright © 2007, 2008 LinFox Serviços em Informatica LTDA.

	This file is part of LibFox.

	LibFox is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	LibFox is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with LibFox.  If not, see <http://www.gnu.org/licenses/>. */

require_once 'lib/xoo.php';

class div_xoo extends xoo
{

	public function property($value,$name)
	{
		return '<div class="'.str_underline($name).'">'.$value."</div>\n";
	}

	public function item($model, $name = false)
	{
		$result = '<div';
		if ($name) $result .= ' class="'.str_underline($name).'"';
		$result .= ">\n";
		foreach ($model as $key => $value) {
			if (!is_array($value) && !is_object($value)) {
				$result .= $this->property($value,$key);
			}
		}
		if ($name) $result .= "</div>\n";

		return $result;
	}

	public function items($array, $model_name, $mode = false)
	{
		$result = '<div';
		if ($mode) $result .= ' class="'.str_underline($mode).'"';
		$result .= ">\n";
		foreach ($array as $model) {
			$result .= $this->item($model,$model_name);
		}
		if ($mode) $result .= "</div>\n";
		
		return $result;
	}

}

?>