<?php

/*	LibFox - Simple library for XML-based backends.
	Copyright © 2007, 2008 LinFox Serviços em Informatica LTDA.

	This file is part of LibFox.

	LibFox is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	LibFox is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with LibFox.  If not, see <http://www.gnu.org/licenses/>. */

require_once 'lib/xoo.php';

class xhtml_xoo extends xoo
{

	public function iterate($model, $key_name = false)
	{
		if ($key_name) {
			$result = '';
		} else {
			$result = '';
		}

		$result .= '<table>';
		
		foreach ($model as $key => $value)
		{
			if (!is_array($value) && !is_object($value)) {
				$result .= '<tr><th>'.$key.'</th><td>'.$value.'</td></tr>';
			}
		}

/*		$result .= '<display>';
		foreach ($this as $key => $value) {
			if (is_object($value)) continue;
			$result .= '<property>';
			$result .= '<name>'.$key.'</name>';
			$result .= '<label>'.$key.'</label>';
			$result .= '<value>'.$value.'</value>';
			$result .= '</property>';
		}
		$result .= '</display>'; */

		$result .= '</table>';
		
		if ($key_name) {
			$result .= '';
		}
 
		return $result;
	}

	public function array_iterate($array, $mode = false, $key_name = false)
	{
		$result = '<table>';
		$first_row = false;
		foreach ($array as $model) {
			if (!$first_row) {
				$result .= '<tr>';
				foreach ($model as $key => $value) {
					$result .= '<th>'.$key.'</th>';
				}
				$result .= '</tr>';
				$first_row = true;
			}
			$result .= '<tr>';
			foreach ($model as $value) {
				$result .= '<td>'.$value.'</td>';
			}
			$result .= '</tr>';
		}
		$result .= '</table>';
		
		return $result;
	}
	
}

?>